diff --git a/src/backend/utils/activity/pgstat_shmem.c b/src/backend/utils/activity/pgstat_shmem.c
index b270c504ea..8fb59191ae 100644
--- a/src/backend/utils/activity/pgstat_shmem.c
+++ b/src/backend/utils/activity/pgstat_shmem.c
@@ -920,9 +920,11 @@ pgstat_reset_entry(PgStat_Kind kind, Oid dboid, Oid objoid, TimestampTz ts)
 	if (!entry_ref || entry_ref->shared_entry->dropped)
 		return;
 
-	pgstat_lock_entry(entry_ref, false);
-	shared_stat_reset_contents(kind, entry_ref->shared_stats, ts);
-	pgstat_unlock_entry(entry_ref);
+	if (pgstat_lock_entry(entry_ref, false))
+	{
+		shared_stat_reset_contents(kind, entry_ref->shared_stats, ts);
+		pgstat_unlock_entry(entry_ref);
+	}
 }